//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "stdio.h"
#include "math.h"
#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "MSCommLib_OCX"
#pragma resource "*.dfm"
TForm1 *Form1;
HANDLE hSerial;
//------------------------------
int check_end=0;
String result_str;
//----------------------------------
Byte power_zero_sign=0;
//----------------------------------
String Reading_Str;
Byte start_record_sign=0; // 0:start, 1: pause, 2: stop
Byte read_cmd_sign=0;
unsigned short record_interval=60;
int record_time=60,total_record_time=3600;
int interval_counter=0;
Byte total_time_chg_sign=0,total_point_chg_sign=0,pause_resume_sign=0;
int total_point=60,left_point_counter=60;
double *power_data;
double laser_power_value;
double max_power,min_power,aver_power,temp_power_sum,rmsdev_power;
Byte power_unit_sign=0;
Byte read_sensor_type_sign=0;
Byte re_cala_sign=0,show_calpanel_sign=0;
double old_cala=1.000,cala=1.000,calb=0,offset=0,aim_power=100;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
        Width=209;
        Height=72;
        Form1->BorderStyle=bsDialog;
        Form1->Caption="Please Select RS232 Port";
}
//---------------------------------------------------------------------------
void TForm1::SendCommand(const AnsiString& cmd) {
    if (hSerial != INVALID_HANDLE_VALUE) {
        DWORD bytesWritten;
        WriteFile(hSerial, cmd.c_str(), cmd.Length(), &bytesWritten, NULL);
    }
}

void TForm1::SearchAvailablePorts()
{
    ComboBox1->Clear();
    AnsiString portName,temp_portName;
    for (int i = 1; i <= 25; i++)
    {
        portName="COM" + IntToStr(i);
        temp_portName=portName;
        if (i > 9)
        {
            temp_portName = "\\\\.\\" + portName;
        }
        HANDLE hPort = CreateFile(temp_portName.c_str(), GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);
        if (hPort != INVALID_HANDLE_VALUE) {
            ComboBox1->Items->Add(portName);
            CloseHandle(hPort);
        }
    }
    if (ComboBox1->Items->Count > 0) {
        ComboBox1->ItemIndex = 0;
    }
}

void __fastcall TForm1::get_rxd_str()
{
    char buffer[20] = {0};
    DWORD bytesRead;
    ReadFile(hSerial, buffer,13, &bytesRead, NULL);
    if(!bytesRead)
        return;
    Reading_Str=buffer;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn1Click(TObject *Sender)
{
    AnsiString fullPortName;
    AnsiString selectedPortName = ComboBox1->Text;
    int portNumber = StrToInt(selectedPortName.SubString(4, selectedPortName.Length() - 3));
    if (portNumber > 9) {
        fullPortName = "\\\\.\\COM" + IntToStr(portNumber);
    } else {
        fullPortName = selectedPortName;
    }

    hSerial = CreateFile(fullPortName.c_str(), GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);

    if (hSerial == INVALID_HANDLE_VALUE) {
        ShowMessage("Failed to open port!");
        return;
    }
    DCB dcbSerialParams = {0};
    dcbSerialParams.DCBlength = sizeof(dcbSerialParams);
    GetCommState(hSerial, &dcbSerialParams);
    dcbSerialParams.BaudRate = CBR_9600;
    dcbSerialParams.ByteSize = 8;
    dcbSerialParams.StopBits = ONESTOPBIT;
    dcbSerialParams.Parity = NOPARITY;
    SetCommState(hSerial, &dcbSerialParams);
  //----------------------------------------------
    COMMTIMEOUTS timeouts = {0};
    timeouts.ReadIntervalTimeout = 50;
    timeouts.ReadTotalTimeoutConstant = 50;
    timeouts.ReadTotalTimeoutMultiplier = 10;
    timeouts.WriteTotalTimeoutConstant = 50;
    timeouts.WriteTotalTimeoutMultiplier = 10;
    SetCommTimeouts(hSerial, &timeouts);
/////////////////////////////////////////////////////////////////
    Caption="Connecting the port...";
    open_main_panel();

}
//---------------------------------------------------------------------------
void __fastcall TForm1::open_main_panel()
{
//----------------------------------------------
        Caption="Laser Power Measurement";
        BorderStyle=bsSizeable;
        Width=554;
        Height=458;
        Form1->Constraints->MaxWidth=Width;
        Form1->Constraints->MaxHeight=Height;
        Chart1->Left=1;
        Chart1->Top=1;
        Panel1->Left=1;
  //---------------------------------------
        Panel6->Visible=false;
  //------------------------------------------
        Reading_Timer->Enabled=true;
  //----------------------------------------------
}
//---------------------------------------------------------------------------
void __fastcall TForm1::get_sensor_type()
{
        char temp_str[20];
        strcpy(temp_str,Reading_Str.c_str());
        if(temp_str[0]<='1'||temp_str[0]=='6')
                power_unit_sign=0;
        else
                power_unit_sign=1;
}
//------------------------------------------------------------------------------
void __fastcall TForm1::cal_laser_power()
{
    char temp_str[]="                ";
    sprintf(temp_str,"%s",Reading_Str.c_str());
    sscanf(temp_str," %lf",&laser_power_value);
    Edit1->Text=String(laser_power_value);
}
//---------------------------------------------------------------------------
Byte get_power_sign=0;
void __fastcall TForm1::Reading_TimerTimer(TObject *Sender)
{
      if(read_cmd_sign==0)
      {
           read_cmd_sign=1;
           if(read_sensor_type_sign==0)
                SendCommand("?ST%");
           else if(re_cala_sign==1||show_calpanel_sign==1)
           {
                if(re_cala_sign==1)
                        re_cala_sign=11;
                else if(show_calpanel_sign==1)
                        show_calpanel_sign=11;
                SendCommand("?cala%");
           }
           else if(re_cala_sign==2||show_calpanel_sign==2)
           {
                if(re_cala_sign==2)
                        re_cala_sign=22;
                else if(show_calpanel_sign==2)
                        show_calpanel_sign=22;
                SendCommand("?calb%");
           }
           else if(re_cala_sign==3)
           {
                re_cala_sign=33;
                SendCommand("?offset%");
           }
           else
           {
                if(power_zero_sign==1)
                        power_zero_sign=2;
                SendCommand("?pw%");
                get_power_sign=1;
           }
      }
      else
      {
           read_cmd_sign=0;
           get_rxd_str();
           if(read_sensor_type_sign==0)
           {
                read_sensor_type_sign=1;
                get_sensor_type();
                return;
           }
           else if(re_cala_sign==11||show_calpanel_sign==11)
           {
                if(re_cala_sign==11)
                        re_cala_sign=2;
                get_rxd_cala();
                if(show_calpanel_sign==11)
                {
                      dis_old_cala();
                      show_calpanel_sign=2;
                }
                return;
           }
           else if(re_cala_sign==22||show_calpanel_sign==22)
           {
                if(re_cala_sign==22)
                        re_cala_sign=3;
                get_rxd_calb();
                if(show_calpanel_sign==22)
                {
                        show_calpanel_sign=0;
                        dis_old_calb();
                }
                return;
           }
           else if(re_cala_sign==33)
           {
                re_cala_sign=4;
                get_rxd_offset();
                return;
           }
   //-------------------------------------------------------
           if(get_power_sign==1)
           {
                cal_laser_power();
                get_power_sign=0;
           }
           if(laser_power_value<-100||laser_power_value>9999)
           {
                Reading_Timer->Enabled=false;
                Edit3->Text=String(" No Connection ");
                connect_error();
                return;
           }

           if(re_cala_sign==4)
           {
                re_cala_sign=0;
                get_new_cala();
                Button3->Enabled=true;
           }
 //--------------------------------------------------------------------
           char str[50];
           if(power_unit_sign==0)
                sprintf(str," P=%gmW",laser_power_value);
           else
                sprintf(str," P=%gW",laser_power_value);

           if(power_zero_sign==2)
           {
                power_zero_sign=0;
                if(power_unit_sign==0)
                {
                        if(laser_power_value>=0)
                                sprintf(str,"calb=-%04d%%",(int)(laser_power_value*10));
                        else
                                sprintf(str,"calb=+%04d%%",(int)(laser_power_value*(-10.0)+0.5));
                        SendCommand(str);
                        Edit9->Text=str;
                }
                else if(power_unit_sign==1)
                {
                        if(laser_power_value>=0)
                                sprintf(str,"calb=-%04d%%",(int)(laser_power_value*1000));
                        else
                                sprintf(str,"calb=+%04d%%",(int)(laser_power_value*(-1000.0)+0.5));
                        SendCommand(str);
                        Edit9->Text=str;
                }

                Button2->Enabled=true;
                Reading_Timer->Interval=200;
           }
            Edit3->Text=str;
//------------------------------------------------------------------
            if(start_record_sign==1)
            {
                if(record_interval==0)
                     record_data();
                else
                {
                     interval_counter++;
                     if(interval_counter>=(record_interval*4))
                     {
                         interval_counter=0;
                         record_data();
                     }
                }
            }
            else if(start_record_sign==0&&interval_counter)
            {
                interval_counter=0;
            }
//------------------------------------------------------------------
      }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::connect_error()
{
       Start1->Enabled=false;
       Pause1->Enabled=false;
       Stop1->Enabled=false;
}
//------------------------------------------------------------------------------
void __fastcall TForm1::record_data()
{
    //--------------------------------------------------------------------------
        unsigned int temp_kk;
        temp_kk=total_point-left_point_counter;
   //------------------------------------------------------------------------
        temp_power_sum+=laser_power_value;
        if(laser_power_value>max_power)
            max_power=laser_power_value;
        else if(laser_power_value<min_power)
            min_power=laser_power_value;
        if((temp_kk+1)>0)
            aver_power=temp_power_sum/(temp_kk+1);
   //----------------------------------------------------------
        char temp_str[15];
        if(max_power<10)
            sprintf(temp_str," Max:%.3fW ",max_power);
        else if(max_power<100)
            sprintf(temp_str," Max:%.2fW ",max_power);
        else sprintf(temp_str," Max:%.1fW ",max_power);
        max_power_text->Caption=temp_str;
     //------------------------------------------
        if(min_power<0)
        {
            if(min_power<-10)
                min_power=-9.999;
            sprintf(temp_str,"Min:-%.3fW ",min_power);
        }
        else if(min_power<10)
            sprintf(temp_str," Min:%.3fW ",min_power);
        else if(min_power<100)
            sprintf(temp_str," Min:%.2fW ",min_power);
        else sprintf(temp_str," Min:%.1fW ",min_power);
        min_power_text->Caption=temp_str;
    //-----------------------------------------------
        if(aver_power<10)
            sprintf(temp_str," Aver:%.4fW ",aver_power);
        else if(aver_power<100)
            sprintf(temp_str," Aver:%.3fW ",aver_power);
        else sprintf(temp_str," Aver:%.2fW ",aver_power);
        aver_power_text->Caption=temp_str;
   //-----------------------------------------------------------
        power_data[temp_kk]=laser_power_value;
        Series1->AddXY(temp_kk,laser_power_value);
    //---------------------------------------------------------------------------
        left_point_counter--;
        if(left_point_counter==0)
        {
                Start1->Enabled=true;
                 Pause1->Enabled=false;
                Stop1->Enabled=false;
                start_record_sign=0;
                cal_rmsdev();
        }
        int temp_left_total_time;
        if(record_interval)
             temp_left_total_time=left_point_counter*record_interval;
        else temp_left_total_time=left_point_counter/4;
        if(temp_left_total_time>=3600)
        {
           Edit8->Text=String((int)(temp_left_total_time/3600));
           Label4->Caption="Hrs ";
       }
      else if(temp_left_total_time>=60)
      {
           Edit8->Text=String((int)(temp_left_total_time/60));
           Label4->Caption="Min ";
      }
      else
      {
           Edit8->Text=String((int)(temp_left_total_time));
           Label4->Caption="Snd ";
      }
}
//-----------------------------------------------------------------------------------
void __fastcall TForm1::Start1Click(TObject *Sender)
{
        Start1->Enabled=false;
        Pause1->Enabled=true;
        Pause1->Caption="&Pause";
        Stop1->Enabled=true;
        Edit8->Text=Edit6->Text;
        if(ComboBox3->ItemIndex==0)
              Label4->Caption="Snd ";
        else if(ComboBox3->ItemIndex==1)
              Label4->Caption="Min ";
        else  Label4->Caption="Hrs ";
        left_point_counter=total_point;
   //---------------------------------------------------
        if(power_data!=NULL)
        {  power_data=NULL; delete power_data; }
        power_data=new double[total_point+1000];
        Series1->Clear();
   //-------------------------------------------------------------
        max_power=-1000; min_power=10000; temp_power_sum=0;
   //----------------------------------------------------------------
        start_record_sign=1;
        pause_resume_sign=0;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Pause1Click(TObject *Sender)
{
    //    Start1->Enabled=true;
        if(pause_resume_sign==0)
        {
                pause_resume_sign=1;
                Pause1->Caption="&Resume";
                start_record_sign=2;
                cal_rmsdev();
        }
        else
        {
                pause_resume_sign=0;
                Pause1->Caption="&Pause";
                start_record_sign=1;
        }
        Stop1->Enabled=true;
  //-----------------------------------------
}
//--------------------------------------------------------------------------
void __fastcall TForm1::cal_rmsdev()
{
        int temp_kk;
        temp_kk=total_point-left_point_counter;
        if(temp_kk<=1)
            return;
        double temp_sum=0;
        int i;
        char temp_str[15];
        for(i=0;i<temp_kk;i++)
           temp_sum+=(power_data[i]-aver_power)*(power_data[i]-aver_power);
        rmsdev_power=sqrt(temp_sum/(temp_kk-1));
        if(rmsdev_power<0.01)
        {
            rmsdev_power*=1000;
            sprintf(temp_str," RmsDev:%.2fmW ",rmsdev_power);
        }
        else if(rmsdev_power<0.1)
        {
            rmsdev_power*=1000;
            sprintf(temp_str," RmsDev:%.1fmW ",rmsdev_power);
        }
        else if(rmsdev_power<1)
        {
            sprintf(temp_str," RmsDev:%.3fW ",rmsdev_power);
        }
        else if(rmsdev_power<10)
            sprintf(temp_str," RmsDev:%.2fW ",rmsdev_power);
        else sprintf(temp_str," RmsDev:over ");
        rmsdev_text->Caption=temp_str;
  //-------------------------------------------
}
//--------------------------------------------------------------------------
void __fastcall TForm1::Stop1Click(TObject *Sender)
{
        Start1->Enabled=true;
        Pause1->Enabled=false;
        Pause1->Caption="&Pause";
        Stop1->Enabled=false;
  //---------------------------------------
        start_record_sign=0;
        pause_resume_sign=0;
  //--------------------------------------
        cal_rmsdev();
   //----------------------------------------------
}
//---------------------------------------------------------------------------
Byte interval_total_not_chg_sign=0;
Byte combox_not_chg_sign=0;
Byte record_time_unit_chg_sign=0;
//---------------------------------------------------------
void __fastcall TForm1::Edit2Change(TObject *Sender)
{
        Start1->Enabled=true;
        Pause1->Enabled=false;
        Pause1->Caption="&Pause";
        Stop1->Enabled=false;
      //---------------------------
        start_record_sign=0;
        pause_resume_sign=0;
//--------------------------------------------------------------------------
        int temp_value;
        temp_value=StrToIntDef(Edit2->Text,-100);
        if(temp_value<0)
            Edit2->Text=String(record_interval);
        else
            record_interval=temp_value;
        interval_total_not_chg_sign=1;
        if(record_interval>=1)
            total_point=total_record_time/record_interval;
        else if(record_interval==0)
            total_point=total_record_time*4;
        Edit7->Text=String(total_point);
   //--------------------------------------------------------------------
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Edit6Change(TObject *Sender)
{

        Start1->Enabled=true;
        Pause1->Enabled=false;
        Pause1->Caption="&Pause";
        Stop1->Enabled=false;
      //---------------------------
        start_record_sign=0;
        pause_resume_sign=0;
///////////////////////////////////////////////////////////////////
      if(total_point_chg_sign==1)
      {
            total_point_chg_sign=0;
            return;
      }
  //---------------------------------------------------
      int temp_value;
      temp_value=StrToIntDef(Edit6->Text,-100);
      if(temp_value<0||temp_value>10000)
           Edit6->Text=String(record_time);
      else record_time=temp_value;
      if(ComboBox3->ItemIndex==0)
            total_record_time=record_time;
      else if(ComboBox3->ItemIndex==1)
            total_record_time=record_time*60;
      else  if(ComboBox3->ItemIndex==2)
            total_record_time=record_time*3600;
      total_time_chg_sign=1;
      if(record_interval)
              total_point=total_record_time/record_interval;
      else total_point=total_record_time*4;
      Edit7->Text=String(total_point);

}
//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox3Change(TObject *Sender)
{
        Start1->Enabled=true;
        Pause1->Enabled=false;
        Pause1->Caption="&Pause";
        Stop1->Enabled=false;
      //---------------------------
        start_record_sign=0;
        pause_resume_sign=0;
//////////////////////////////////////////////////////////
      if(combox_not_chg_sign==1)
      {
           combox_not_chg_sign=0;
           return;
      }
      record_time_unit_chg_sign=1;
      if(ComboBox3->ItemIndex==0)
            total_record_time=record_time;
      else if(ComboBox3->ItemIndex==1)
            total_record_time=record_time*60;
      else  if(ComboBox3->ItemIndex==2)
            total_record_time=record_time*3600;

      total_time_chg_sign=1;
      if(record_interval)
           total_point=total_record_time/record_interval;
      else total_point=total_record_time*4;
      Edit7->Text=String(total_point);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Edit7Change(TObject *Sender)
{
        Start1->Enabled=true;
        Pause1->Enabled=false;
        Pause1->Caption="&Pause";
        Stop1->Enabled=false;
      //---------------------------
        start_record_sign=0;
        pause_resume_sign=0;
///////////////////////////////////////////////////////////////
        if(total_time_chg_sign==1)
        {
            total_time_chg_sign=0;
            return;
        }
        if(record_time_unit_chg_sign==1)
        {
              record_time_unit_chg_sign=0;
              return;
        }
        if(interval_total_not_chg_sign==1)
        {
              interval_total_not_chg_sign=0;
              return;
        }
    //---------------------------------------------
      int temp_value;
      temp_value=StrToIntDef(Edit7->Text,-100);
      if(temp_value<0)
      {
           Edit7->Text=String(record_time);
           return;
      }
      else
           total_point=temp_value;
      total_point_chg_sign=1;
      if(record_interval)
         total_record_time=total_point*record_interval;
      else total_record_time=total_point/4;
      if(total_record_time>=36000)
      {
         record_time=(int)(total_record_time/3600.0+0.5);
         Edit7->Text=String(record_time);
         ComboBox3->ItemIndex=2;
      }
      else if(total_record_time>=600)
      {
         record_time=(int)(total_record_time/60.0+0.5);
         Edit7->Text=String(record_time);
         ComboBox3->ItemIndex=1;
      }
      else
      {
         record_time=total_record_time;
         Edit7->Text=String(record_time);
         ComboBox3->ItemIndex=0;
      }
      combox_not_chg_sign=1;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Data1Click(TObject *Sender)
{
        SaveDialog1->Filter="*.txt|*.txt";
        if(!SaveDialog1->Execute())
           return;
        String str,sub_str;
        str=SaveDialog1->FileName;
        sub_str=str.SubString(str.Length()-3,4);
        if(sub_str.AnsiCompare(".txt"))
             str=str+".txt";
   //--------------------------------------------------
        int i;
        FILE *stream;
        stream=fopen(str.c_str(),"w+");
        if(record_interval)
        {
             for(i=0;i<(total_point-left_point_counter);i++)
                   fprintf(stream,"%d    %lf \n",i*record_interval,power_data[i]);
        }
        else
        {
             for(i=0;i<(total_point-left_point_counter);i++)
                   fprintf(stream,"%.2f    %g \n",i/4.0,power_data[i]);
        }
        fclose(stream);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Curve1Click(TObject *Sender)
{
       SaveDialog1->Filter="*.bmp|*.bmp";
       if(!SaveDialog1->Execute())
          return;
        String str,sub_str;
        str=SaveDialog1->FileName;
        sub_str=str.SubString(str.Length()-3,4);
        if(sub_str.AnsiCompare(".bmp"))
             str=str+".bmp";
    //---------------------------------------------------
       Chart1->SaveToBitmapFile(str);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
      if(power_data)
      {
          power_data=NULL;
          delete power_data;
      }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
    SearchAvailablePorts();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
        Panel5->Visible=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Calibration1Click(TObject *Sender)
{
        Panel5->Visible=true;
        show_calpanel_sign=1;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)
{
        Byte temp_result;
        temp_result=0;
        temp_result=MessageBox(Handle,"Save calibration data?","Warning",1);
        if(temp_result==1)
        {
               get_rxd_str();
               Sleep(200);
               SendCommand("saveall%");
               Sleep(500);
               get_rxd_str();
               ShowMessage(Reading_Str);
        }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{
      SendCommand("zero%");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
      Button2->Enabled=false;
      SendCommand("deloft%");
      SendCommand("calb=+0000%%");
      Reading_Timer->Enabled=false;
      power_zero_sign=1;
      Reading_Timer->Interval=1000;
      Reading_Timer->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button7Click(TObject *Sender)
{
      String temp_str;
      temp_str=Edit9->Text;
      SendCommand(temp_str.c_str());
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
        aim_power=StrToFloatDef(Edit4->Text,-100);
        if(aim_power<=0)
                return;
        re_cala_sign=1;
        Button3->Enabled=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::get_rxd_cala()
{
        //cala=1.000
        String temp_str;
        Byte str_len,i;
        char rxd_str[25],get_str[25];
        temp_str=Reading_Str;
        str_len=temp_str.Length();
        if(str_len<10)
                return;
        strcpy(rxd_str,temp_str.c_str());
        for(i=5;i<10;i++)
                get_str[i-5]=rxd_str[i];
        get_str[i-5]='\0';
        old_cala=StrToFloatDef(get_str,-10);
        if(old_cala<0||old_cala>=10)
                old_cala=1.000;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::get_rxd_calb()
{
        // calb=+1
        String temp_str;
        Byte str_len,i;
        char rxd_str[25],get_str[25];
        temp_str=Reading_Str;
        str_len=temp_str.Length();
        if(str_len<7)
        {
                calb=0;
                return;
        }
        strcpy(rxd_str,temp_str.c_str());
        for(i=5;i<str_len;i++)
                get_str[i-5]=rxd_str[i];
        get_str[i-5]='\0';
        calb=StrToFloatDef(get_str,-100);
        if(calb<=-10||calb>=10)
                calb=0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::get_rxd_offset()
{
        //offset=-0.000
        String temp_str;
        Byte str_len,i;
        char rxd_str[26],get_str[26];
        temp_str=Reading_Str;
        str_len=temp_str.Length();
        if(str_len<12)
        {
                calb=0;
                return;
        }
        strcpy(rxd_str,temp_str.c_str());
        for(i=7;i<str_len;i++)
                get_str[i-7]=rxd_str[i];
        get_str[i-7]='\0';
        offset=StrToFloatDef(get_str,-100);
        if(offset<=-10||offset>=10)
                offset=0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::get_new_cala()
{
        char temp_str[20];
        if(power_unit_sign==0)
             cala=old_cala*(aim_power-offset-100.0*calb)/(laser_power_value-offset-100.0*calb);
        else if(power_unit_sign==1)
             cala=old_cala*(aim_power-offset-calb)/(laser_power_value-offset-calb);

        sprintf(temp_str,"cala=%04d%",(int)(cala*1000+0.5));
        SendCommand(temp_str);
        Edit5->Text=temp_str;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::dis_old_cala()
{
        char temp_str[20];
        sprintf(temp_str,"cala=%04d%",(int)(old_cala*1000+0.5));
        Edit5->Text=temp_str;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::dis_old_calb()
{
        char temp_str[20];
        if(calb<0)
             sprintf(temp_str,"calb=%05d%",(int)(calb*1000));
        else
             sprintf(temp_str,"calb=+%04d%%",(int)(calb*1000.0));
        Edit9->Text=temp_str;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button6Click(TObject *Sender)
{
      String temp_str;
      temp_str=Edit5->Text;
      SendCommand(temp_str.c_str());
}
//---------------------------------------------------------------------------

